Index: src/org/jboss/tools/internal/deltacloud/ui/utils/UIUtils.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/utils/UIUtils.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/utils/UIUtils.java	(working copy)
@@ -17,71 +17,132 @@
 import org.eclipse.core.runtime.Assert;
 import org.eclipse.core.runtime.IAdaptable;
 import org.eclipse.core.runtime.Platform;
-import org.eclipse.jface.action.ContributionManager;
-import org.eclipse.jface.action.GroupMarker;
-import org.eclipse.jface.action.IContributionManager;
-import org.eclipse.jface.action.IMenuManager;
-import org.eclipse.jface.action.MenuManager;
-import org.eclipse.jface.dialogs.IDialogSettings;
-import org.eclipse.jface.resource.ImageDescriptor;
-import org.eclipse.jface.resource.JFaceResources;
+import org.eclipse.core.runtime.preferences.InstanceScope;
+import org.eclipse.jface.bindings.keys.KeyStroke;
+import org.eclipse.jface.dialogs.Dialog;
+import org.eclipse.jface.dialogs.MessageDialogWithToggle;
+import org.eclipse.jface.fieldassist.ContentProposalAdapter;
+import org.eclipse.jface.fieldassist.ControlDecoration;
+import org.eclipse.jface.fieldassist.FieldDecorationRegistry;
+import org.eclipse.jface.fieldassist.SimpleContentProposalProvider;
+import org.eclipse.jface.fieldassist.TextContentAdapter;
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.swt.events.DisposeEvent;
-import org.eclipse.swt.events.DisposeListener;
-import org.eclipse.swt.layout.FormAttachment;
-import org.eclipse.swt.layout.FormData;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.FocusAdapter;
+import org.eclipse.swt.events.FocusEvent;
+import org.eclipse.swt.graphics.Image;
 import org.eclipse.swt.widgets.Control;
-import org.eclipse.swt.widgets.Menu;
 import org.eclipse.swt.widgets.Shell;
-import org.eclipse.ui.IEditorPart;
-import org.eclipse.ui.IWorkbench;
-import org.eclipse.ui.IWorkbenchActionConstants;
-import org.eclipse.ui.IWorkbenchPage;
-import org.eclipse.ui.IWorkbenchPartSite;
-import org.eclipse.ui.IWorkbenchWindow;
-import org.eclipse.ui.PartInitException;
-import org.eclipse.ui.PlatformUI;
-import org.eclipse.ui.menus.IMenuService;
-import org.eclipse.ui.part.EditorPart;
-import org.eclipse.ui.plugin.AbstractUIPlugin;
+import org.eclipse.swt.widgets.Text;
+import org.jboss.tools.deltacloud.ui.Activator;
+import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
+import org.jboss.tools.deltacloud.ui.preferences.StringsPreferenceValue;
+import org.osgi.service.prefs.Preferences;
 
 /**
  * @author Andre Dietisheim
  */
 public class UIUtils {
 
-	private static final String CONTEXT_MENU_PREFIX = "popup:";
-	private static final String VIEW_MENU_PREFIX = "menu:";
-	
-	private UIUtils() {
+	public static ContentProposalAdapter createPreferencesProposalAdapter(final Text text, String preferencesKey) {
+		final ControlDecoration decoration = createContenAssistDecoration(text);
+
+		final StringsPreferenceValue preferencesValues =
+				new StringsPreferenceValue(',', preferencesKey, Activator.PLUGIN_ID);
+		SimpleContentProposalProvider proposalProvider = new SimpleContentProposalProvider(preferencesValues.get());
+		proposalProvider.setFiltering(true);
+		text.addFocusListener(new FocusAdapter() {
+
+			@Override
+			public void focusGained(FocusEvent e) {
+				decoration.show();
+			}
+
+			@Override
+			public void focusLost(FocusEvent e) {
+				decoration.hide();
+				String value = text.getText();
+				if (value != null && value.length() > 0) {
+					preferencesValues.add(text.getText());
+					preferencesValues.store();
+				}
+			}
+
+		});
+		KeyStroke keyStroke = KeyStroke.getInstance(SWT.CONTROL, ' ');
+		ContentProposalAdapter proposalAdapter =
+				new ContentProposalAdapter(text, new TextContentAdapter(), proposalProvider, keyStroke, null);
+		proposalAdapter.setProposalAcceptanceStyle(ContentProposalAdapter.PROPOSAL_REPLACE);
+		return proposalAdapter;
 	}
 
-	/**
-	 * Returns the selection of the active workbench window.
-	 * 
-	 * @return the selection
-	 * 
-	 * @see IWorkbenchWindow#getSelectionService()
-	 */
-	public static ISelection getWorkbenchWindowSelection() {
-		return getActiveWorkbenchWindow().getSelectionService().getSelection();
+	private static ControlDecoration createContenAssistDecoration(Control control) {
+		ControlDecoration decoration = new ControlDecoration(control, SWT.RIGHT | SWT.TOP);
+		Image errorImage = FieldDecorationRegistry.getDefault()
+				.getFieldDecoration(FieldDecorationRegistry.DEC_CONTENT_PROPOSAL).getImage();
+		decoration.setImage(errorImage);
+		decoration.setDescriptionText("History available");
+		decoration.setShowHover(true);
+		decoration.hide();
+		return decoration;
+	}
+
+	public static ControlDecoration createErrorDecoration(String errorText, Control control) {
+		return createDecoration(errorText, FieldDecorationRegistry.DEC_ERROR, control);
+	}
+
+	public static ControlDecoration createDecoration(String text, String imageKey, Control control) {
+		ControlDecoration decoration = new ControlDecoration(control, SWT.LEFT | SWT.TOP);
+		Image errorImage = FieldDecorationRegistry.getDefault()
+				.getFieldDecoration(imageKey).getImage();
+		decoration.setImage(errorImage);
+		decoration.setDescriptionText(text);
+		decoration.setShowHover(true);
+		decoration.hide();
+		return decoration;
 	}
 
 	/**
-	 * Gets the structured selection.
+	 * Opens a confirmation dialog that offers a checkbox that allows the user
+	 * to turn further aksing off. The checkbox state is stored to the
+	 * preferences
 	 * 
-	 * @return the structured selection
+	 * @param title
+	 *            dialog title
+	 * @param message
+	 *            dialog message
+	 * @param dontShowAgainMessage
+	 *            message for further asking ("dont show this dialog again")
+	 * @param preferencesKey
+	 *            the preferences key to store state of further asking
+	 * @param pluginId
+	 *            the plugin id to use when storing the preferences
+	 * @param shell
+	 *            the shell to use
+	 * @return true, if successful
 	 */
-	public static IStructuredSelection getStructuredSelection() {
-		ISelection selection = getWorkbenchWindowSelection();
-		if (selection instanceof IStructuredSelection) {
-			return (IStructuredSelection) selection;
-		} else {
-			return null;
+	public static boolean openConfirmationDialog(String title, String message, String dontShowAgainMessage,
+			String preferencesKey, String pluginId, Shell shell) {
+		boolean confirmed = true;
+		Preferences prefs = new InstanceScope().getNode(pluginId);
+		boolean dontShowDialog =
+				prefs.getBoolean(preferencesKey, false);
+		if (!dontShowDialog) {
+			MessageDialogWithToggle dialog =
+					MessageDialogWithToggle.openOkCancelConfirm(shell, title, message, dontShowAgainMessage,
+							false, null, null);
+			confirmed = dialog.getReturnCode() == Dialog.OK;
+			boolean toggleState = dialog.getToggleState();
+			// If warning turned off by user, set the preference for future
+			// usage
+			if (toggleState) {
+				prefs.putBoolean(IDeltaCloudPreferenceConstants.DONT_CONFIRM_CREATE_INSTANCE, true);
+			}
 		}
+		return confirmed;
 	}
-
+	
 	/**
 	 * Gets the first element of a given selection in the given type. Returns
 	 * <code>null</null> if selection is selection is empty or adaption of the first element in 
@@ -93,6 +154,7 @@
 	 *            the expected class
 	 * 
 	 * @return the first element
+	 * @deprecated
 	 */
 	public static <T> T getFirstAdaptedElement(final ISelection selection, final Class<T> expectedClass) {
 		if (selection == null) {
@@ -106,27 +168,7 @@
 			return adapt(firstElement, expectedClass);
 		}
 	}
-
-	/**
-	 * Returns <code>true</code> if the given selection holds exactly 1 element
-	 * of the given type.
-	 * 
-	 * @param selection
-	 *            the selection to check
-	 * @param expectedClass
-	 *            the expected class
-	 * @return <code>true</code>, if the given selection holds a single element
-	 *         of the given type.
-	 */
-	public static <T> boolean isSingleSelection(final ISelection selection, final Class<T> expectedClass) {
-		if (!(selection instanceof IStructuredSelection)) {
-			return false;
-		}
-
-		return ((IStructuredSelection) selection).toList().size() == 1
-				&& getFirstAdaptedElement(selection, expectedClass) != null;
-	}
-
+	
 	public static <T> List<T> adapt(Collection<?> objects, Class<T> expectedClass) {
 		List<T> adaptedObjects = new ArrayList<T>();
 		for (Object object : objects) {
@@ -137,7 +179,7 @@
 		}
 		return adaptedObjects;
 	}
-	
+
 	/**
 	 * Adapts the given object to the given type. Returns <code>null</code> if
 	 * the given adaption is not possible. Adaption is tried by casting and by adapting it.
@@ -146,6 +188,7 @@
 	 * @param object
 	 * @param expectedClass
 	 * @return
+	 * @deprecated
 	 */
 	@SuppressWarnings("unchecked")
 	public static <T> T adapt(Object object, Class<T> expectedClass) {
@@ -167,209 +210,4 @@
 		}
 	}
 
-	/**
-	 * Gets the active page.
-	 * 
-	 * @return the active page
-	 */
-	public static IWorkbenchPage getActivePage() {
-		IWorkbenchPage workbenchPage = getActiveWorkbenchWindow().getActivePage();
-		Assert.isNotNull(workbenchPage);
-		return workbenchPage;
-	}
-
-	/**
-	 * Returns the editor that's currently active (focused).
-	 * 
-	 * @return the active editor
-	 */
-	public static IEditorPart getActiveEditor() {
-		IEditorPart editor = getActivePage().getActiveEditor();
-		Assert.isNotNull(editor);
-		return editor;
-	}
-
-	/**
-	 * Gets the active workbench window.
-	 * 
-	 * @return the active workbench window
-	 */
-	public static IWorkbenchWindow getActiveWorkbenchWindow() {
-		IWorkbenchWindow workbenchWindow = getWorkbench().getActiveWorkbenchWindow();
-		Assert.isNotNull(workbenchWindow);
-		return workbenchWindow;
-	}
-
-	public static Shell getActiveShell() {
-		Shell shell = getActiveWorkbenchWindow().getShell();
-		Assert.isTrue(shell != null && !shell.isDisposed());
-		return shell;
-	}
-
-	/**
-	 * Gets the workbench.
-	 * 
-	 * @return the workbench
-	 */
-	public static IWorkbench getWorkbench() {
-		IWorkbench workbench = PlatformUI.getWorkbench();
-		Assert.isNotNull(workbench);
-		return workbench;
-	}
-
-	/**
-	 * Replaces an image with the given key by the given image descriptor.
-	 * 
-	 * @param imageKey
-	 *            the image key
-	 * @param imageDescriptor
-	 *            the image descriptor
-	 */
-	public static void replaceInJfaceImageRegistry(final String imageKey, final ImageDescriptor imageDescriptor) {
-		Assert.isNotNull(imageKey);
-		Assert.isNotNull(imageDescriptor);
-
-		JFaceResources.getImageRegistry().remove(imageKey);
-		JFaceResources.getImageRegistry().put(imageKey, imageDescriptor);
-	}
-
-	/**
-	 * Register the given ContributionManager with the given id. The
-	 * contribution manager gets unregistered on control disposal.
-	 * 
-	 * @param id
-	 *            the id
-	 * @param contributionManager
-	 *            the contribution manager
-	 * @param control
-	 *            the control
-	 * 
-	 * @see ContributionManager
-	 * @see IMenuService
-	 * @see DisposeListener
-	 */
-	public static void registerContributionManager(final String id, final IContributionManager contributionManager,
-			final Control control) {
-		Assert.isNotNull(id);
-		Assert.isNotNull(contributionManager);
-		Assert.isTrue(control != null && !control.isDisposed());
-
-		final IMenuService menuService = (IMenuService) PlatformUI.getWorkbench().getService(IMenuService.class);
-		menuService.populateContributionManager((ContributionManager) contributionManager, id);
-		contributionManager.update(true);
-		control.addDisposeListener(new DisposeListener()
-		{
-			public void widgetDisposed(DisposeEvent e)
-			{
-				menuService.releaseContributions((ContributionManager) contributionManager);
-			}
-		});
-	}
-	
-	public static String getContextMenuId(String viewId) {
-		return new StringBuffer(CONTEXT_MENU_PREFIX).append(viewId).toString();
-	}
-	
-	public static String getViewMenuId(String viewId) {
-		return new StringBuffer(VIEW_MENU_PREFIX).append(viewId).toString();
-	}
-
-	/**
-	 * Creates context menu to a given control.
-	 * 
-	 * @param control
-	 *            the control
-	 * 
-	 * @return the i menu manager
-	 */
-	public static IMenuManager createContextMenu(final Control control) {
-		Assert.isTrue(control != null && !control.isDisposed());
-
-		MenuManager menuManager = new MenuManager();
-		menuManager.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
-
-		Menu menu = menuManager.createContextMenu(control);
-		control.setMenu(menu);
-		return menuManager;
-	}
-
-	/**
-	 * Gets the dialog settings for the given identifer and plugin.
-	 * 
-	 * @param identifier
-	 *            the identifier
-	 * @param plugin
-	 *            the plugin
-	 * 
-	 * @return the dialog settings
-	 */
-	public static IDialogSettings getDialogSettings(final String identifier, final AbstractUIPlugin plugin) {
-		Assert.isNotNull(plugin);
-		IDialogSettings dialogSettings = plugin.getDialogSettings();
-		IDialogSettings section = dialogSettings.getSection(identifier);
-		if (section == null) {
-			section = dialogSettings.addNewSection(identifier);
-		}
-		return section;
-	}
-
-	/**
-	 * Returns the page for a given editor.
-	 * 
-	 * @param editor
-	 *            the editor
-	 * @return
-	 * 
-	 * @return the page
-	 * 
-	 * @see IWorkbenchPage
-	 */
-	public static IWorkbenchPage getPage(EditorPart editor) {
-		Assert.isNotNull(editor);
-		IWorkbenchPartSite site = editor.getSite();
-		Assert.isNotNull(site);
-		return site.getPage();
-	}
-
-	public static void showView(String viewId) throws PartInitException {
-		Assert.isLegal(viewId != null && viewId.length() > 0);
-		getActivePage().showView(viewId);
-	}
-
-	
-	/**
-	 * This method has been stolen from AS-Tools' UIUtil class 
-	 * and is useful for creating FormData objects
-	 */
-	public static FormData createFormData(
-			Object topStart, int topOffset, 
-			Object bottomStart, int bottomOffset, 
-			Object leftStart, int leftOffset, 
-			Object rightStart, int rightOffset) {
-		
-			FormData data = new FormData();
-
-			if( topStart != null ) {
-				data.top = topStart instanceof Control ? new FormAttachment((Control)topStart, topOffset) : 
-					new FormAttachment(((Integer)topStart).intValue(), topOffset);
-			}
-
-			if( bottomStart != null ) {
-				data.bottom = bottomStart instanceof Control ? new FormAttachment((Control)bottomStart, bottomOffset) : 
-					new FormAttachment(((Integer)bottomStart).intValue(), bottomOffset);
-			}
-
-			if( leftStart != null ) {
-				data.left = leftStart instanceof Control ? new FormAttachment((Control)leftStart, leftOffset) : 
-					new FormAttachment(((Integer)leftStart).intValue(), leftOffset);
-			}
-
-			if( rightStart != null ) {
-				data.right = rightStart instanceof Control ? new FormAttachment((Control)rightStart, rightOffset) : 
-					new FormAttachment(((Integer)rightStart).intValue(), rightOffset);
-			}
-			return data;
-		}
-
-
 }
Index: src/org/jboss/tools/deltacloud/ui/views/Columns.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/Columns.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/Columns.java	(working copy)
@@ -24,8 +24,8 @@
 		private String name;
 		private int weight;
 
-		public Column(String name, int weight) {
-			this.name = name;
+		public Column(String nameKey, int weight) {
+			this.name = CVMessages.getString(nameKey);
 			this.weight = weight;
 		}
 
Index: src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/views/cloudelements/AbstractCloudElementTableView.java	(working copy)
@@ -46,16 +46,17 @@
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudException;
 import org.jboss.tools.deltacloud.core.DeltaCloudManager;
+import org.jboss.tools.deltacloud.core.ICloudElementFilter;
 import org.jboss.tools.deltacloud.core.IDeltaCloudElement;
 import org.jboss.tools.deltacloud.core.IDeltaCloudManagerListener;
 import org.jboss.tools.deltacloud.core.IInstanceFilter;
 import org.jboss.tools.deltacloud.ui.Activator;
 import org.jboss.tools.deltacloud.ui.ErrorUtils;
+import org.jboss.tools.deltacloud.ui.preferences.StringPreferenceValue;
 import org.jboss.tools.deltacloud.ui.views.CVMessages;
 import org.jboss.tools.deltacloud.ui.views.Columns;
 import org.jboss.tools.deltacloud.ui.views.Columns.Column;
-import org.jboss.tools.internal.deltacloud.ui.preferences.StringPreferenceValue;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * A common superclass for viewers that operate on IDeltaCloudElements
@@ -77,10 +78,12 @@
 
 	private Combo currentCloudSelector;
 	private Label currentCloudSelectorLabel;
+	private Label filteredLabel;
+	private Composite container;
 	private TableViewer viewer;
 	private DeltaCloud currentCloud;
+
 	private StringPreferenceValue lastSelectedCloudPref;
-	private Composite container;
 
 	private ModifyListener currentCloudModifyListener = new ModifyListener() {
 
@@ -101,6 +104,7 @@
 
 					@Override
 					public void run() {
+						updateFilteredLabel();
 						setViewerInput(currentCloud);
 					}
 				});
@@ -114,7 +118,7 @@
 		public void selectionChanged(IWorkbenchPart part, ISelection selection) {
 			// we want to listen to selection changes in the deltacloud view
 			// only
-			DeltaCloud cloud = UIUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
+			DeltaCloud cloud = WorkbenchUtils.getFirstAdaptedElement(selection, DeltaCloud.class);
 			if (isNewCloud(cloud)) {
 				int index = getCloudIndex(cloud, getClouds());
 				currentCloudSelector.select(index);
@@ -173,9 +177,10 @@
 		createCloudSelector(container);
 		initCloudSelector(lastSelectedCloudPref.get(), currentCloudSelector, clouds);
 
-		Label filterLabel = new Label(container, SWT.NULL);
-		filterLabel.setText(CVMessages.getString(FILTERED_LABEL));
-		filterLabel.setToolTipText(CVMessages.getString(FILTERED_TOOLTIP));
+		this.filteredLabel = new Label(container, SWT.NULL);
+		filteredLabel.setText(CVMessages.getString(FILTERED_LABEL));
+		filteredLabel.setToolTipText(CVMessages.getString(FILTERED_TOOLTIP));
+		updateFilteredLabel();
 
 		Composite tableArea = new Composite(container, SWT.NULL);
 		viewer = createTableViewer(tableArea);
@@ -183,7 +188,7 @@
 		currentCloud = getCloud(currentCloudSelector.getSelectionIndex(), clouds);
 		addPropertyChangeListener(currentCloud);
 		setViewerInput(currentCloud);
-		setFilterLabelVisible(currentCloud, filterLabel);
+		setFilterLabelVisible(currentCloud, filteredLabel);
 
 		Point p1 = currentCloudSelectorLabel.computeSize(SWT.DEFAULT, SWT.DEFAULT);
 		Point p2 = currentCloudSelector.computeSize(SWT.DEFAULT, SWT.DEFAULT);
@@ -202,7 +207,7 @@
 		f = new FormData();
 		f.top = new FormAttachment(0, 5 + centering);
 		f.right = new FormAttachment(100, -10);
-		filterLabel.setLayoutData(f);
+		filteredLabel.setLayoutData(f);
 
 		f = new FormData();
 		f.top = new FormAttachment(currentCloudSelector, 8);
@@ -223,25 +228,22 @@
 	private TableViewer createTableViewer(Composite tableArea) {
 		TableColumnLayout tableLayout = new TableColumnLayout();
 		tableArea.setLayout(tableLayout);
-
-		TableViewer viewer = new TableViewer(tableArea,
-				SWT.FULL_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.MULTI);
+		TableViewer viewer = new TableViewer(
+				tableArea, SWT.FULL_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.MULTI);
 		Table table = viewer.getTable();
 		table.setHeaderVisible(true);
 		table.setLinesVisible(true);
 		ITableContentAndLabelProvider<CLOUDELEMENT> provider = getContentAndLabelProvider();
 		viewer.setContentProvider(provider);
 		viewer.setLabelProvider(provider);
-		createColumns(provider, tableLayout, table);
-
+		createColumns(provider.getColumns(), tableLayout, table);
 		viewer.setComparator(new TableViewerColumnComparator());
 		table.setSortDirection(SWT.NONE);
-
 		return viewer;
 	}
 
 	protected abstract ITableContentAndLabelProvider<CLOUDELEMENT> getContentAndLabelProvider();
-	
+
 	private void setViewerInput(DeltaCloud cloud) {
 		viewer.setInput(cloud);
 	}
@@ -295,7 +297,7 @@
 		}
 
 		IInstanceFilter filter = currentCloud.getInstanceFilter();
-		filterLabel.setVisible(!filter.toString().equals(IInstanceFilter.ALL_STRING));
+		filterLabel.setVisible(!filter.isFiltering());
 	}
 
 	private DeltaCloud getCloud(int cloudIndex, DeltaCloud[] clouds) {
@@ -306,17 +308,16 @@
 		return clouds[cloudIndex];
 	}
 
-	private void createColumns(ITableContentAndLabelProvider<CLOUDELEMENT> provider, TableColumnLayout tableLayout, Table table) {
-		Columns<CLOUDELEMENT> columns = provider.getColumns();
-		
+	private void createColumns(Columns<CLOUDELEMENT> columns, TableColumnLayout tableLayout, Table table) {
 		for (int i = 0; i < columns.getSize(); ++i) {
 			Column<CLOUDELEMENT> c = columns.getColumn(i);
 			TableColumn tc = new TableColumn(table, SWT.NONE);
 			if (i == 0) {
 				table.setSortColumn(tc);
 			}
-			tc.setText(CVMessages.getString(c.getName()));
 			tableLayout.setColumnData(tc, new ColumnWeightData(c.getWeight(), true));
+			tc.setText(c.getName());
+			tc.setMoveable(true);
 			tc.addSelectionListener(new ColumnListener(i));
 		}
 	}
@@ -338,8 +339,8 @@
 	}
 
 	private void hookContextMenu(Control control) {
-		IMenuManager contextMenu = UIUtils.createContextMenu(control);
-		UIUtils.registerContributionManager(UIUtils.getContextMenuId(getViewID()), contextMenu, control);
+		IMenuManager contextMenu = WorkbenchUtils.createContextMenu(control);
+		WorkbenchUtils.registerContributionManager(WorkbenchUtils.getContextMenuId(getViewID()), contextMenu, control);
 	}
 
 	protected abstract String getViewID();
@@ -373,27 +374,33 @@
 		container.layout(true, true);
 	}
 
-	public void cloudsChanged(int type, DeltaCloud cloud) {
-		DeltaCloud[] clouds = getClouds();
-		switch (type) {
-		case IDeltaCloudManagerListener.REMOVE_EVENT:
-			onCloudRemoved(cloud, clouds);
-			break;
-		default:
-		}
-		
-		int index = getCloudIndex(currentCloud, clouds);
-		String[] cloudNames = toCloudNames(clouds);
-		setCloudSelectorItems(cloudNames, currentCloudSelector);
+	public void cloudsChanged(final int type, final DeltaCloud cloud) {
+		viewer.getControl().getDisplay().syncExec(new Runnable() {
 
-		if (cloudNames.length > 0) {
-			currentCloudSelector.setText(cloudNames[index]);
-			setViewerInput(currentCloud);
-		} else {
-			currentCloudSelector.setText("");
-			setViewerInput(null);
+			@Override
+			public void run() {
+				DeltaCloud[] clouds = getClouds();
+				switch (type) {
+				case IDeltaCloudManagerListener.REMOVE_EVENT:
+					onCloudRemoved(cloud, clouds);
+					break;
+				default:
+				}
+
+			int index = getCloudIndex(currentCloud, clouds);
+			String[] cloudNames = toCloudNames(clouds);
+			setCloudSelectorItems(cloudNames, currentCloudSelector);
+
+			if (cloudNames.length > 0) {
+				currentCloudSelector.setText(cloudNames[index]);
+				setViewerInput(currentCloud);
+			} else {
+				currentCloudSelector.setText("");
+				setViewerInput(null);
+			}
+			container.layout(true, true);
 		}
-		container.layout(true, true);
+		});
 	}
 
 	private void onCloudRemoved(DeltaCloud cloud, DeltaCloud[] clouds) {
@@ -456,4 +463,21 @@
 			return super.getAdapter(adapter);
 		}
 	}
+
+	protected void updateFilteredLabel() {
+		filteredLabel.getDisplay().syncExec(new Runnable() {
+
+			@Override
+			public void run() {
+				boolean visible = false;
+				if (currentCloud != null) {
+					ICloudElementFilter<CLOUDELEMENT> filter = getFilter(currentCloud);
+					visible = filter.isFiltering();
+				}
+				filteredLabel.setVisible(visible);
+			}
+		});
+	}
+
+	protected abstract ICloudElementFilter<CLOUDELEMENT> getFilter(DeltaCloud cloud);
 }
Index: src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstanceWizard.java
===================================================================
--- src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstanceWizard.java	(revision 29180)
+++ src/org/jboss/tools/internal/deltacloud/ui/wizards/NewInstanceWizard.java	(working copy)
@@ -11,10 +11,6 @@
 package org.jboss.tools.internal.deltacloud.ui.wizards;
 
 import org.eclipse.core.runtime.Assert;
-import org.eclipse.core.runtime.preferences.InstanceScope;
-import org.eclipse.jface.dialogs.Dialog;
-import org.eclipse.jface.dialogs.MessageDialogWithToggle;
-import org.eclipse.jface.wizard.Wizard;
 import org.jboss.tools.common.jobs.ChainedJob;
 import org.jboss.tools.deltacloud.core.DeltaCloud;
 import org.jboss.tools.deltacloud.core.DeltaCloudException;
@@ -26,13 +22,13 @@
 import org.jboss.tools.deltacloud.ui.ErrorUtils;
 import org.jboss.tools.deltacloud.ui.IDeltaCloudPreferenceConstants;
 import org.jboss.tools.deltacloud.ui.wizard.INewInstanceWizardPage;
-import org.osgi.service.prefs.Preferences;
+import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
 
 /**
  * @author Jeff Johnston
  * @author André Dieitsheim
  */
-public class NewInstanceWizard extends Wizard {
+public class NewInstanceWizard extends AbstractDeltaCloudWizard {
 
 	private final static String CREATE_INSTANCE_FAILURE_TITLE = "CreateInstanceError.title"; //$NON-NLS-1$
 	private final static String CREATE_INSTANCE_FAILURE_MSG = "CreateInstanceError.msg"; //$NON-NLS-1$
@@ -43,7 +39,6 @@
 
 	protected NewInstancePage mainPage;
 	protected INewInstanceWizardPage[] additionalPages;
-	protected DeltaCloud cloud;
 	protected DeltaCloudInstance instance;
 	/**
 	 * Initial image, may be null
@@ -51,7 +46,7 @@
 	private DeltaCloudImage image;
 
 	public NewInstanceWizard(DeltaCloud cloud) {
-		this.cloud = cloud;
+		super(cloud);
 		try {
 			this.image = cloud.getLastImage();
 		} catch (DeltaCloudException e) {
@@ -66,7 +61,7 @@
 
 	@Override
 	public void addPages() {
-		mainPage = new NewInstancePage(cloud, image);
+		mainPage = new NewInstancePage(getDeltaCloud(), image);
 		addPage(mainPage);
 		additionalPages = DeltacloudUIExtensionManager.getDefault().loadNewInstanceWizardPages();
 		for (int i = 0; i < additionalPages.length; i++) {
@@ -96,18 +91,23 @@
 		String name = model.getName();
 
 		// Save persistent settings for this particular cloud
+		DeltaCloud cloud = getDeltaCloud();
 		cloud.setLastImageId(imageId);
 		cloud.setLastKeyname(keyId);
 
 		boolean result = false;
 		Exception e = null;
 		try {
-			if (isProceed()) {
+			if (UIUtils.openConfirmationDialog(
+					WizardMessages.getString(CONFIRM_CREATE_TITLE), WizardMessages.getString(CONFIRM_CREATE_MSG),
+					WizardMessages.getString(DONT_SHOW_THIS_AGAIN_MSG),
+					IDeltaCloudPreferenceConstants.DONT_CONFIRM_CREATE_INSTANCE, Activator.PLUGIN_ID, getShell())) {
+
 				instance = cloud.createInstance(name, imageId, realmId, profileId, keyId, memory, storage);
 				if (instance != null) {
 					result = true;
 					if (instance.getState().equals(DeltaCloudInstance.State.PENDING)) {
-						scheduleJobs();
+						scheduleJobs(instance);
 					}
 				}
 			}
@@ -125,17 +125,17 @@
 		return result;
 	}
 
-	private void scheduleJobs() {
+	private void scheduleJobs(DeltaCloudInstance instance) {
 		ChainedJob first =
 				new InstanceStateJob(
-						WizardMessages.getFormattedString(STARTING_INSTANCE_TITLE, instance.getName()),
+						WizardMessages.getFormattedString(STARTING_INSTANCE_TITLE, instance.getAlias()),
 						instance,
 						DeltaCloudInstance.State.RUNNING);
 		first.setUser(true);
 		ChainedJob last = first;
 		ChainedJob temp;
 		for (int i = 0; i < additionalPages.length; i++) {
-			temp = additionalPages[i].getPerformFinishJob(instance);
+			temp = additionalPages[i].createPerformFinishJob(instance);
 			if (temp != null) {
 				last.setNextJob(temp);
 				last = temp;
@@ -143,27 +143,4 @@
 		}
 		first.schedule();
 	}
-
-	private boolean isProceed() {
-		boolean proceed = true;
-		Preferences prefs = new InstanceScope().getNode(Activator.PLUGIN_ID);
-		boolean dontShowDialog =
-				prefs.getBoolean(IDeltaCloudPreferenceConstants.DONT_CONFIRM_CREATE_INSTANCE, false);
-		if (!dontShowDialog) {
-			MessageDialogWithToggle dialog =
-					MessageDialogWithToggle.openOkCancelConfirm(getShell(),
-							WizardMessages.getString(CONFIRM_CREATE_TITLE),
-							WizardMessages.getString(CONFIRM_CREATE_MSG),
-							WizardMessages.getString(DONT_SHOW_THIS_AGAIN_MSG),
-							false, null, null);
-			proceed = dialog.getReturnCode() == Dialog.OK;
-			boolean toggleState = dialog.getToggleState();
-			// If warning turned off by user, set the preference for future
-			// usage
-			if (toggleState) {
-				prefs.putBoolean(IDeltaCloudPreferenceConstants.DONT_CONFIRM_CREATE_INSTANCE, true);
-			}
-		}
-		return proceed;
-	}
-}
+}
\ No newline at end of file
Index: src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudInstanceDialog.java
===================================================================
--- src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudInstanceDialog.java	(revision 29180)
+++ src/org/jboss/tools/deltacloud/ui/commands/DeltaCloudInstanceDialog.java	(working copy)
@@ -10,6 +10,7 @@
  ******************************************************************************/
 package org.jboss.tools.deltacloud.ui.commands;
 
+import java.util.ArrayList;
 import java.util.Collection;
 
 import org.eclipse.jface.viewers.ArrayContentProvider;
@@ -17,7 +18,7 @@
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.dialogs.ListSelectionDialog;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
-import org.jboss.tools.internal.deltacloud.ui.utils.UIUtils;
+import org.jboss.tools.internal.deltacloud.ui.utils.WorkbenchUtils;
 
 /**
  * A dialog that allows the user to select CVInstanceElements
@@ -28,7 +29,7 @@
 
 	private static class DeltaCloudInstanceNameProvider extends LabelProvider {
 		public String getText(Object element) {
-			DeltaCloudInstance instance = UIUtils.adapt(element, DeltaCloudInstance.class);
+			DeltaCloudInstance instance = WorkbenchUtils.adapt(element, DeltaCloudInstance.class);
 			if (instance != null) {
 				return instance.getName();
 			} else {
@@ -45,4 +46,13 @@
 				, message);
 		setTitle(title);
 	}
+	
+	public DeltaCloudInstance[] getResult2() {
+		ArrayList<DeltaCloudInstance> result = new ArrayList<DeltaCloudInstance>();
+		Object[] supArr = super.getResult();
+		for( int i = 0; i < supArr.length; i++ ) {
+			result.add((DeltaCloudInstance)supArr[i]);
+		}
+		return result.toArray(new DeltaCloudInstance[result.size()]);
+	}
 }
\ No newline at end of file
